jQuery(function () {
    var $ = jQuery;

    var form = $('#woo-dostavista-warehouse-edit form:first');

    form.submit(function (e) {
        e.preventDefault();

        licode.preloader.on(form);

        var data = {};
        form.find(':input').each(function () {
            var jInput = $(this);
            var name = jInput.attr('name');
            if (typeof (name) !== 'undefined') {
                data[name] = jInput.is(':checkbox') ? jInput.prop('checked') : jInput.val();
            }
        });

        if (form.data('id')) {
            data['id'] = form.data('id');
        }

        woodostavista.frontendHttpClient.storeWarehouse(data, function(success, error, parameterErrors, response) {
            if (success) {
                window.location.href = response.redirect_url;
            } else {
                licode.preloader.off(form);
                alert(woodostavista.warehouse.translation.save_error);
            }
        });
    });

    var packageLoader = new woodostavista.packagesLoader();
    packageLoader.onJqueryUiAutocompleteLoaded(function (isJqueryUiAutocompleteEnabled) {
        var addressInput = form.find('input[name="address"]:first');
        if (addressInput.hasClass('address-suggests') && isJqueryUiAutocompleteEnabled) {
            form.find('input[name="city"]:first').hide();
            var warehouseAddress = new woodostavista.form.address(addressInput, addressInput.parent());
            // На изменение адреса город сохраняем отдельно
            warehouseAddress.onChange(function (data) {
                var selectedWarehouseCity = data.city;
                var selectedWarehouseStreet = data.street;

                form.find('input[name="city"]:first').val(selectedWarehouseCity);

                if (!selectedWarehouseCity) {
                    alert(woodostavista.warehouse.translation.address_suggestions_fail_city_required);
                }

                if (!selectedWarehouseStreet) {
                    alert(woodostavista.warehouse.translation.address_suggestions_fail_street_required);
                }
            });
        } else {
            form.find('input[name="city"]:first').show();
        }

        addressInput.on('change', function (){
            var cityInput = form.find('input[name="city"]:first');

            if (!cityInput.val()) {
                cityInput.parents('tr:first').removeClass('hidden');
                cityInput.show();
            } else {
                cityInput.parents('tr:first').addClass('hidden');
                cityInput.hide();
            }
        });
    });
});
