<?php

use WooDostavista\View\JsonResponse;

defined('ABSPATH') || exit;

class WC_Dostavista_Address_Suggestions_Controller
{
    public static function get_address_suggestions()
    {
        global $wpdb;

        $postBody = file_get_contents('php://input');
        $data     = json_decode($postBody, true) ?? [];

        if (!$data) {
            (new JsonResponse(['error' => 'required_post_data'], 500))->render();
            exit();
        }

        $query = (trim(urldecode($data['query'])) ?? null);

        if (!$query) {
            (new JsonResponse(['error' => 'required_query'], 500))->render();
            exit();
        }

        $dvServiceLocator = WC_Dostavista_Service_Locator::getInstance();

        $geoSuggestionService = $dvServiceLocator->getGeoSuggestionService();

        $suggestionAddresses = $geoSuggestionService->getSuggestionAddressesByAddress($query);

        $addresses = [];

        foreach ($suggestionAddresses as $suggestionAddress) {
            $addresses[] = [
                'address' => $suggestionAddress->getAddress(),
                'city'    => $suggestionAddress->getCity(),
                'street'  => $suggestionAddress->getStreet(),
            ];
        }

        (new JsonResponse(
            [
                'is_successfully' => true,
                'suggestions'     => $addresses,
            ]
        ))->render();
    }
}
