<?php

namespace WooDostavista\DvCmsModuleApiClient\Enums;

use WC_Dostavista_Lang;
use WooDostavista\ModuleConfig\ModuleConfig;

class VehicleTypeEnum
{
    const TYPE_WALK          = 6;
    const TYPE_MOTORBIKE     = 8;
    const TYPE_CAR           = 7;
    const TYPE_TRUCK_PICKUP  = 1;
    const TYPE_TRUCK_MINIVAN = 2;
    const TYPE_TRUCK_PORTER  = 3;
    const TYPE_TRUCK_VAN     = 4;

    private static function getEnum(): array
    {
        return [
            static::TYPE_WALK          => WC_Dostavista_Lang::getHtml('vehicle_type_enum_walk'),
            static::TYPE_CAR           => WC_Dostavista_Lang::getHtml('vehicle_type_enum_car'),
            static::TYPE_TRUCK_PICKUP  => WC_Dostavista_Lang::getHtml('vehicle_type_enum_truck_pickup'),
            static::TYPE_TRUCK_MINIVAN => WC_Dostavista_Lang::getHtml('vehicle_type_enum_truck_minivan'),
            static::TYPE_TRUCK_PORTER  => WC_Dostavista_Lang::getHtml('vehicle_type_enum_truck_porter'),
            static::TYPE_TRUCK_VAN     => WC_Dostavista_Lang::getHtml('vehicle_type_enum_truck_van'),
            static::TYPE_MOTORBIKE     => WC_Dostavista_Lang::getHtml('vehicle_type_enum_motorbike'),
        ];
    }

    public static function getAvailableVehicleTypes(): array
    {
        $moduleConfig = new ModuleConfig();

        $availableTypes = [];

        foreach (static::getEnum() as $typeId => $typeName) {
            if (in_array($typeId, $moduleConfig->getAvailableVehicleTypes())) {
                $availableTypes[$typeId] = $typeName;
            }
        }

        return $availableTypes;
    }
}
